## file: Rcodes-chap06-statmodel.r
## usage: source('Rcodes-chap06-statmodel.r',echo=TRUE,max.deparse.length=Inf)
## required file: optdigits.tra
msg <- "------------------------ Type  <Return> to continue ------------------------: "
require(doParallel)                # foreach(vZ)
cl <- makeCluster(detectCores())    # NX^̍쐬
registerDoParallel(cl)


## xϑf[^(morley)̃vbg
data(morley)               # f[^ǂݍ
dat <- morley[,3]+299000   # f[^␳
hist(dat,breaks=seq(299600, 300100, by=20), col=5, ylim=c(0,17))   # vbg


readline(msg)
## lzU[0,1]̃p[^FŖސ
x <- runif(10)   ## f[^ 10
max(x)           ## Ŗސ
x <- runif(100)  ## f[^ 100
max(x)           ## Ŗސ


readline(msg)
## lzU[0,1]̃p[^Fsΐ
n <- 10                 # f[^
x <- runif(n)           # f[^
((n+1)/n) * max(x)      # sΐ
## 100Zbg̃f[^𐶐
X <- matrix(runif(100*n),100,n)
mean(apply(X,1,max))           # Ŗސ̕ϒl: applyōsX̊esmaxKp
mean(((n+1)/n)*apply(X,1,max)) # sΐ̕ϒl


readline(msg)
## ŖސF\^`q^̔䗦𐄒
## ̑ΐޓxvZ֐
nlikelihood <- function(theta,n){
  a <- theta[1]
  b <- theta[2]
  o <- 1-a-b
  # ml̑ΐꂼvZ
  logA  <- log(a^2+2*a*o)
  logB  <- log(b^2+2*b*o)
  logAB <- log(2*a*b)
  logO  <- log(o^2)
  # ̑ΐޓx
  -sum(n*c(logA, logB, logAB, logO))
}
## Ŗސ(mle)߂֐
mle <- function(n){
  # œǨvZ
  op <- optim(c(1/3,1/3),nlikelihood,n=n) 
  # o
  list(a=op$par[1],b=op$par[2],o=1-op$par[1]-op$par[2])
}
## source('bloodtype.r')   # vOǂݍ


readline(msg)
## \^`q^̔䗦𐄒F DA:40lCB:30lCAB:10lCO: 20l
mle(c(40,30,10,20))  


readline(msg)
## EMASYōŖސFxk[Cz

## x:(f[^n, d) ^s. K:R|[lg. 
EM_mixBernoulli <- function(x,K=5,maxitr=1000,tol=1e-5){
  d <- ncol(x); n <- nrow(x)         # dƃf[^n
  eps <- .Machine$double.eps         
  ## R|[lgݒ
  mu <- mean(x)                      
  p <- matrix(rbeta(K*d,shape1=mu,shape2=(1-mu)),K)
  q <- rep(1/K,K)                    # m̏l
  ul <- Inf
  for(itr in 1:maxitr){              # EMASY
    ## xk[Cz̊mvZ
    mp <- exp(log(p)%*%t(x)+log(1-p)%*%t(1-x))*q
    ## , q, p XVDpmin, pmax ŔUhD
    gmm <- pmin(pmax(t(t(mp)/colSums(mp)),eps),1-eps)
    q <- pmin(pmax(rowSums(gmm)/n, eps),1-eps)
    p <- pmin(pmax((gmm%*%x)/(n*q),eps),1-eps)
    ## ̑ΐޓx̏E
    uln <- -sum(gmm*((log(p)%*%t(x)+log(1-p)%*%t(1-x)+log(q))-log(gmm)))
    if(abs(ul-uln)<tol){           # ~
      break
    }
    ul <- uln
  }
  BIC <- ul+0.5*(d*K+(K-1))*log(n) # BIC
  list(p=p,q=q,gamma=gmm,BIC=BIC)
}
## source('statmodel-em.r')


readline(msg)
## Foptdigits.tra ɓKp
a <- read.table('optdigits.tra',sep=',')  # f[^Ǎ
x <- as.matrix(a[,1:64]>8)      ## 16iK8ȉ0ƂC9ȏ1ɕϊ
y <- as.factor(a[,65])          ## e摜f[^̃xDf̐ɂ͎gȂ
est <- EM_mixBernoulli(x,K=10)  ## xk[CzŃf[^̕z𐄒:R|[lg10
ec <- apply(est$gamma,2,which.max)  ## ef[^ǂ̃R|[lgɑvZ 
table(y[which(ec==1)])   ## 1R|[lgɑf[^̃x\
table(y[which(ec==2)])   ## 2R|[lgɑf[^̃x\ 
est$BIC  # BIC̒l


readline(msg)
## Rz[lg K(5-50) ɑ΂ BIC
Klist <- 5:50
BIC_list <- foreach(K=Klist,.combine=c)%dopar%{ # vZ
  est <- EM_mixBernoulli(x,K=K,maxitr=1000,tol=1e-5)
  est$BIC
}
plot(BIC_list)          # vbg
stopCluster(cl)         # vZI 
