## file: Rcodes-chap08-regression.r
## usage: source('Rcodes-chap08-regression.r',echo=TRUE,max.deparse.length=Inf)
msg <- "------------------------ Type  <Return> to continue ------------------------: "
require(car)       # UNf[^
require(MASS)      # rlm
require(glmnet)    # glmnet
require(kernlab)   # kernelMatrix
require(CVST)      # constructData


## ŏ@
data(UN)       # f[^ǂݍ
## f[^̃vbg 
plot(UN[,2],UN[,1],log='xy',xlab=colnames(UN)[2],ylab=colnames(UN)[1])
logUN <- log(na.omit(UN))                   # f[^ΐŕϊ
res <- lm(infant.mortality~gdp,data=logUN)  # ŏ@
res                                         
y <- predict(res)                           # \l
lines(exp(cbind(logUN$gdp,y)),col=2,lwd=2)  # A֐vbg


readline(msg)
## Ol܂ރf[^ɍŏ@Kp
data(Davis)                        # f[^ǂݍ
a <- lm(height~weight,data=Davis)  # ŏ@
a
readline(msg)
lm(height~weight,data=Davis[-12,]) # ŏ@(12ԃf[^)

readline(msg)
## oXgA
b <- rlm(height~weight,data=Davis)   # rlmɂ郍oXgA
b
## f[^̃vbg  
plot(Davis$weight,Davis$height,xlab='weight',ylab='height')
tx <- data.frame(weight=seq(40,160,l=100))       # \_
lines(tx$weight,predict(a,tx),col=2,lwd=3)       # ŏ@̃vbg()
lines(tx$weight,predict(b,tx),col=4,lwd=3,lty=2) # oXg̃vbg(j)


readline(msg)
## oXgAFrlm֐̃IvV psi.bisquare ƂĐ   
rlm(height~weight,data=Davis,psi="psi.bisquare")


readline(msg)
## bWA
n <- 100                             # f[^
degree <- 8                          # f̎
lambda_candidate <- 2^c(-12,-6,0,6)  # p[^̌
## f[^
x <- runif(n,min=-2,max=2)
y <- sin(2*pi*x)/x + rnorm(n,sd=0.5)
## f[^s
Phi <- outer(x,0:degree,FUN="^")
IE  <- diag(ncol(Phi)); IE[1,1] <- 0
## p[^
par <- c()
for(lambda in lambda_candidate){
  par <- cbind(par, solve(t(Phi)%*%Phi+lambda*IE,t(Phi)%*%y))
}
## vbg
plot(x,y,lwd=2)                              # f[^_vbg
x_test   <- seq(-2,2,l=100)                  # eXg_
Phi_test <- outer(x_test,0:degree,FUN="^")   # eXg_ł̃f[^s
for (i in 1:ncol(par)){
  ypred <- c(Phi_test %*% par[,i])           # \l
  lines(x_test, ypred, lty=i, lwd=2, col=2)  # \l̃vbg
}
legend("topright", paste("lambda=2^(",c(-12,-6,0,6),")",sep=""),lty=1:4,lwd=rep(2,4),col=rep(2,4))



readline(msg)
## bWAFglmnet ֐g
n <- 100           # f[^
degree <- 8        # f̎
lambda <- 2^(-12)  # p[^
## f[^
x <- runif(n,min=-2,max=2)
y <- sin(2*pi*x)/x + rnorm(n,sd=0.5)
## f[^s
Phi <- outer(x,1:degree,FUN="^")
## glmnetɂ郊bWA
gl <- glmnet(Phi,y,alpha=0,family="gaussian",lambda=lambda/n)
gl


readline(msg)
## 肵A֐vbg
tx <- seq(-2,2,l=100)                 # eXg_
testPhi <- outer(tx,1:degree,FUN="^") # eXg_ł̃f[^s
predy <- predict(gl,newx=testPhi)     # \l
## vbg
plot(x,y)
lines(tx,predy,lwd=2,col=2)


readline(msg)
## 10̐p[^ɑ΂ĉA֐𐄒
gl <- glmnet(Phi[,-1],y,alpha=0,family="gaussian",nlambda=10)
gl$a0     ## ꂼ̐p[^Ő肳ꂽ萔̒l
gl$beta   ## ꂼ̐p[^Ő肳ꂽWp[^


readline(msg)
## p[^ 10^(-6:1) ƂăbWADʂvbg
gl <- glmnet(Phi,y,alpha=0,family="gaussian",lambda=10^(-6:1))
tx <- seq(-2,2,l=100)                    # eXg_
testPhi <- outer(tx,1:degree,FUN="^")    # eXg_ł̃f[^s
## \lF(eXg_̐, lambdǎ␔)̍s 
predy <- predict(gl,newx=testPhi)        
plot(x,y)                                # f[^_̃vbg
for(i in 1:ncol(predy)){
  lines(tx,predy[,i],col=2)              # \l̃vbg
}


readline(msg)
## J[lA
n <- 100                                 # f[^
## f[^
x <- matrix(runif(n,min=-4,max=4))
y <- sin(pi*x)/x + rnorm(n,sd=0.5)
sigma  <- 3                              # J[lp[^̐ݒ
K <- kernelMatrix(rbfdot(sigma=sigma),x) # KEXJ[l̃Os
lambda <- 1                              # p[^ݒ
## J[lA̋ɒlɌsƃxNg
extK <- rbind(cbind(rep(1,n), K+lambda*diag(n)), c(n, rowSums(K)))
exty <- c(y,sum(y))
## p[^vZ
par <- solve(extK, exty)
theta0 <- par[1]; alpha <- par[-1]
## vbg
predy <- theta0 + K %*% alpha
plot(x,y)
lines(cbind(x,predy)[order(x),],col=2,lwd=2)


readline(msg)
## CVSTpbP[WgăJ[lA
dat <- constructData(x=x,y=c(y))          # f[^
n <- getN(dat)                            # f[^̎擾
## J[lp[^̐ 
par <- list(kernel="rbfdot",sigma=sigma,lambda=lambda/n)
KRR <- constructKRRLearner()              # IuWFNg
m <- KRR$learn(dat, par)                  # f[^wK
predyCV <- KRR$predict(m, dat)            # \
plot(dat)                                 # vbg
lines(cbind(dat$x,predyCV)[order(dat$x),],col=2,lwd=2)
##
predy2  <- K %*% solve(K+diag(lambda,n),y)  # Os񂩂\lvZ
mean(abs(predyCV-predy2))                   # 2ނ̌vZ@̕ό덷
