## file: Rcodes-chap11-sparse.r
## usage: source('Rcodes-chap11-sparse.r',echo=TRUE,max.deparse.length=Inf)
## required files: Rlogo.jpg, boat.png, goldhill.png, lena.png
msg <- "------------------------ Type  <Return> to continue ------------------------: "
require(glmnet)          # glmnet
require(genlasso)        # fusedlasso1d, fusedlasso2d
require(huge)            # huge, huge.generator
require(jpeg)            # readJPEG


n <- 30       # f[^
d <- 50       # p[^̎
s <- 10       # p[^̔[vf
## f[^
beta <- c(rep(1,s),rep(0,d-s))
X <- matrix(rnorm(n*d),n)
y <- X %*% beta + rnorm(n,sd=0.01)
##
la <- glmnet(X,y,alpha=1)                    # b\
ri <- glmnet(X,y,alpha=0)                    # bW
## vbg
par(mfrow=c(1,2))
plot(la$b[1:d,ncol(la$b)],lwd=2,type='h',main="b\")    # b\
plot(ri$b[1:d,ncol(ri$b)],lwd=2,type='h',main="bW")    # bW


readline(msg)
## pXǐՂ̃vbg
plot(la,main="b\")       # b\
plot(ri,main="bW")       # bW


readline(msg)
## GXeBbNlbg
n <- 100; d <- 200; s <- 30         # ݒFf[^, , [vf
beta <- c(rep(1,s),rep(0,d-s))      # ^̃p[^
## f[^
X <- matrix(rnorm(n*d),n)
y <- X %*% beta + rnorm(n,sd=0.01)
la <- glmnet(X,y,alpha=1)           # b\ŊwK
el <- glmnet(X,y,alpha=0.1)         # GXeBbNlbgŊwK
## vbg
par(mfrow=c(1,1))
plot(colSums(abs(el$b)),colSums(el$b!=0),col=2,type='l',        # GXeBbNlbg
     lwd=2,xlab='L1 norm',ylab="[vf̐")                     
lines(colSums(abs(la$b)),colSums(la$b!=0),lwd=2,lty=2)                 # b\
lines(cbind(colSums(abs(el$b)),n),lty=3)
legend("topleft",c("GXeBbNlbg","b\"),col=c(2,1),lty=c(1,2),lwd=c(2,2),bg="white")


readline(msg)
## t[YhEb\
## f[^
beta <- rnorm(5)%x%rep(1,10) 
y <- beta+rnorm(50,sd=0.2)
res <- fusedlasso1d(y)   # t[YhEb\ɂ鐄
par(mfrow=c(1,2))
plot(y,main="f[^")                            # f[^̃vbg
lines(beta,col=2)
plot(res,main="t[YhEb\ɂ鐄茋")   # t[YhEb\ɂ鐄茋ʂvbg 


readline(msg)
## 2Ńt[YhEb\
imgy <- readJPEG("Rlogo.jpg")       # 摜f[^ǂݍ
z <- y <- t(apply(imgy[,,3],2,rev))                    # y: 摜
i <- sample(prod(dim(y)),round(prod(dim(y))/5))        # mCŸʒu
z[i] <- pmin(pmax(z[i] + rnorm(length(i),sd=0.2),0),1) # z: ϑ摜
image(y,col=gray((0:32)/32),main="摜")              # 摜̃vbg
image(z,col=gray((0:32)/32),main="ϑ摜")            # ϑ摜̃vbg
readline(msg)
##    2Ńt[YhEb\̌vZFԂ邽 maxsteps=1000 őł؂
readline(msg)
system.time(res <- fusedlasso2d(z,maxsteps=1000,verbose=T)) # ԒZk̂ maxsteps ݒ
image(matrix(res$beta[,1000],nrow(y)),col=gray((0:32)/32),  # wKʂ̗vbg
      main="maxsteps=1000 ̌") 
res$lambda[1000]                                            # ̂Ƃ̐p[^̒l
## res <- fusedlasso2d(z,maxsteps=Inf,verbose=T)  # =0 ƓɂȂ܂ŌvZ(Ԃ)
## length(res$lambda)                             # pXǐՂŌvZp[^̌
## image(matrix(res$beta[,12000],nrow(y)),col=gray((0:32)/32))   # wKʂ̗vbg
## res$lambda[12000]                              # ̂Ƃ̐p[^̒l


readline(msg)
## Xn[XEVXeBbNA
n <- 100; d <- 200; s <- 30     ## ݒFf[^CC[vf
theta <- c(rep(1,s),rep(0,d-s)) ## ^̃p[^ݒ
## f[^
X <- matrix(rnorm(n*d),n)
y <- X%*%theta+rnorm(n,sd=0.001)>=0   
## p[^
la <- glmnet(X,y,family='binomial',alpha=1)    # L1 
ri <- glmnet(X,y,family='binomial',alpha=0)    # L2 
## vbgF̃IvV͏ȗ
par(mfrow=c(1,2))
plot(la$b[1:d,ncol(la$b)],type='h',main="WXeBbNAFL1 ")   # L1 
plot(ri$b[1:d,ncol(ri$b)],type='h',main="WXeBbNAFL2 ")   # L2 



readline(msg)
## OtBJEb\
n <- 100; d <- 5                # ݒFf[^C
x <- huge.generator(n,d,p=0.5)  # lHf[^Cp͕ӂ𐶐m
x$sparsity                      # xs̃Xp[Xx
x$theta                         # xs̃p^[


readline(msg)
## OtBJEb\: ʂ̃vbg
n <- 1000; d <- 20                # ݒFf[^C
x <- huge.generator(n,d,p=0.05)   # lHf[^Cp͕ӂ𐶐m
res <- huge(x$data)               # OtBJEb\ɂ鐄
par(mfrow=c(1,1))
plot(res)                         # ʂvbg


readline(msg)
## OtBJEb\ stockdata ɓKp
data(stockdata)       # f[^ǂݍ
dim(stockdata$data)   # f[^̃TCY
res <- huge(stockdata$data)
plot(res)


readline(msg)
## wK: skip

## library(spams)    #  spams g
## library(png)      #  readPNG g
## ## 摜f[^ǂݍ
## A <- readPNG('boat.png')
## B <- readPNG('goldhill.png')
## C <- readPNG('lena.png')
## ## 3̉摜8x8̉摜pb`؂oD܂Ƃ߂ăf[^s X 쐬D
## X <- cbind(spams.im2col_sliding(A,8,8),spams.im2col_sliding(B,8,8),spams.im2col_sliding(C,8,8))
## dim(X)
## ## 摜pb`̕\
## par(mfrow=c(10,10),mai=rep(0,4))
## for(i in 1:100){ # _ɉ摜pb`Iŕ\
##   image(matrix(X[,sample(ncol(X),1)],8),axes=FALSE,col=gray((0:32)/32))
## }


## readline(msg)
## ## wK
## D <- spams.trainDL(X,K=100,lambda1=1)              # wK
## for(i in 1:ncol(D)){                               # vbg
##   image(matrix(D[,i],8),axes=FALSE,col=gray((0:32)/32))
## }
