## file: Rcodes-chap12-ensemble.r
## usage: source('Rcodes-chap12-ensemble.r',echo=TRUE,max.deparse.length=Inf)
msg <- "------------------------ Type  <Return> to continue ------------------------: "
require(rpart)                     # rpart, stagec f[^
require(rpart.plot)                # rpart.plot
require(randomForest)              # randomForest
require(kernlab)                   # spam f[^
require(adabag)                    # bagging, bagging
require(ada)                       # ada
require(xgboost)                   # xgboost, xgb.cv, xgb.train
require(doParallel)                # foreach(vZ)
registerDoParallel(detectCores())  # NX^̍쐬


stagec$pgstat <- as.factor(stagec$pgstat)   # f[^̏o̓x쐬
## fO
fm <- as.formula(paste("pgstat~",paste(dimnames(stagec)[[2]][3:8],collapse='+')))
rp  <- rpart(fm,data=stagec)    # rpartŊwK
rp$control$cp                   # ɑΉ鐳p[^̃ftHgl
## ؂vbg
par(mfrow=c(1,2))
plot(rp,main=paste("p[^:",rp$control$cp)); text(rp,use.n=TRUE,all=TRUE,xpd=NA)
## p[^傫rpartŊwK
rq <- rpart(fm,data=stagec,control=rpart.control(cp=0.05))
## ؂vbg
plot(rq,main=paste("p[^:",rq$control$cp)); text(rq,use.n=TRUE,all=TRUE,xpd=NA)


readline(msg)
## rpart ̌ʂ rpart.plot Ńvbg
rpart.plot(rq,main="rpart.plot Ńvbg")       # vbg


readline(msg)
## oMO: iris f[^ɓKp
idx <- sample(nrow(iris),100)      # iris 100f[^Ńg[jOCcŃeXg
ba <- bagging(Species~.,data=iris[idx,],mfinal=50)   # bagging: B=50
pred <- predict(ba,iris[-idx,])    # \x
pred$error                         # eXg덷
pred$confusion                     # \xƐ^̃x̑Ή


readline(msg)
## oMO: stagecf[^ɓKp
## BςăeXg덷r
B <- c(10,50,100)                   # baggingB=10,50,100
stagec$pgstat <- as.factor(stagec$pgstat)    # stagecf[^wK
## fO
fm <- as.formula(paste("pgstat ~", paste(dimnames(stagec)[[2]][3:8],collapse='+')))
## ewK@20vZDʂtesterrɊi[
testerr <- foreach(i=1:20,.combine=rbind,.packages=c("rpart","adabag"))%dopar%{
  idx <- sample(nrow(stagec),100)                         # f[^TvO
  rp  <- rpart(fm,data=stagec[idx,])                      # rpartŊwK
  err <- mean(predict(rp,stagec[-idx,],type='c')!=stagec[-idx,'pgstat'])  # eXg덷
  for(b in B){                                            # baggingŊwKEeXg
    ba  <- bagging(fm,data=stagec[idx,],mfinal=b)
    err <- c(err,predict(ba,stagec[-idx,])$error)
  }
  err
}
## boxplotŃvbg
par(mfrow=c(1,1))
dimnames(testerr)[[2]] <- c('rpart',paste('bagging',B,sep=''))
boxplot(testerr, main="rpart  bagging ̃eXg덷")
colMeans(testerr)                                         # ʂ\


readline(msg)
## _tHXg
stagec$pgstat <- as.factor(stagec$pgstat)  # f[^
## fO
fm <- as.formula(paste("pgstat ~",paste(dimnames(stagec)[[2]][3:8],collapse='+')))
## _tHXgŊwK (na.omit NAf[^)
idx <- sample(nrow(stagec),100)
rf <- randomForest(fm, data=stagec[idx,], na.action=na.omit)
rf                                              # ʂ\
predy <- predict(rf,stagec[-idx,])              # ؃f[^Ńx\
mean(predy!=stagec[-idx,"pgstat"],na.rm=TRUE)   # ،덷
plot(rf,main="_tHXg̃eXg덷CFNR(), FPR()")      # ʂvbg


readline(msg)
## x\Fadaboost  xgboost r
data(soldat)                       # f[^ǂݍ
dim(soldat)     
## 5631Tvœ͂72Co̓x 0, 1 2l
x <- soldat[,-73]; y <- soldat[,73]; y[y==-1] <- 0  
T <- 2000                          # u[XeBO̔񐔂2000
mp <- 1                            # wK̖؂̐[ 1 (芔)
idx <- sample(nrow(x),4000)
tr <- list(x=x[ idx,],y=y[ idx])    # g[jOf[^
te <- list(x=x[-idx,],y=y[-idx])    # eXgf[^
## A_u[Xg (vZԂv) 
## system.time(boE <- ada(tr$x,tr$y,loss='e',iter=T, control=rpart.control(maxdepth=mp))) # Ԃ̂ŃRgAEg
## mean(predict(boE,te$x)!=te$y)                                                          # A_u[Xg̃eXg덷
## xgboost (vZԂv)
system.time(boL <- xgboost(data=as.matrix(tr$x),label=tr$y,nround=T, max.depth=mp,objective="binary:logistic",verbose=FALSE))
mean((predict(boL,as.matrix(te$x))>1/2)!=te$y) # xgboost̃eXg덷


readline(msg)
## x\F_tHXg XGBoost r
dat <- na.omit(soldat)              # NA
x <- dat[,-73]; y <- dat[,73]; y[y==-1] <- 0  
idx <- sample(nrow(x),3000)
tr <- list(x=x[ idx,],y=y[ idx])    # g[jOf[^
te <- list(x=x[-idx,],y=y[-idx])    # eXgf[^
## _tHXg
system.time(rf <- randomForest(tr$x,as.factor(tr$y),ntree=1000))
## XGBoost
system.time(boL <- xgboost(data=as.matrix(tr$x),label=tr$y,nround=1000,objective="binary:logistic",verbose=0))
# eXg덷
mean(predict(rf,te$x)!=te$y)        # _tHXg̃eXg덷
mean((predict(boL,as.matrix(te$x))>1/2)!=te$y) # XGBoost̃eXg덷



readline(msg)
## 0-1ɑ΂œKȔ؂ŋ߂Fsoldat f[^
T <- 5000                      # ͍ő5000  
mp <- 1                        # wK͌芔
K <- 5                         # 5-ؖ@
# ؖ@ (vZԂv)
system.time(boLcv <- xgb.cv(data=as.matrix(tr$x),label=tr$y,nfold=K,nrounds=T,
                            max.depth=mp,metrics="error",objective="binary:logistic", verbose=F))
##
optT <- which.min(boLcv[[4]]$test_error_mean)               # ؖ@狁߂œKȔŊwK
boL  <- xgboost(data=as.matrix(tr$x),label=tr$y,nround=optT,
               max.depth=mp,objective="binary:logistic",verbose=FALSE)
testerr <- mean((predict(boL,as.matrix(te$x))>1/2)!=te$y); testerr              # eXg덷
# g[jO덷ƌ،덷vbg
par(ps=16,mai=c(1,1,1,1))
ylim <- range(c(boLcv[[4]]$train_error_mean,boLcv[[4]]$test_error_mean))
 plot(boLcv[[4]]$train_error_mean,col=1,lty=1,lwd=2,xlab="",ylab="덷",ylim=ylim,type='l',main="soldat f[^")
lines(boLcv[[4]]$test_error_mean, col=2,lty=2,lwd=2)
lines(cbind(0:T,testerr),lty=3,lwd=2)
legend('topright',c("،덷","g[jO덷","eXg덷"),col=c(2,1,1),lwd=c(2,2,2),lty=c(2,1,3),y.intersp=1.4)



readline(msg)
## 0-1ɑ΂œKȔ؂ŋ߂Fspam f[^
data(spam)
x <- spam[,-58]; y <- as.numeric(spam[,58]=='spam')
idx <- sample(nrow(x),3000)
tr <- list(x=x[ idx,],y=y[ idx])  # g[jOf[^
te <- list(x=x[-idx,],y=y[-idx])  # eXgf[^
T <- 2000                         # ͍ő5000  
mp <- 5                           # wK͌芔
K <- 5                            # 5-ؖ@
## ؖ@ (vZԂv)
system.time(boLcv <- xgb.cv(data=as.matrix(tr$x),label=tr$y,nfold=K,nrounds=T,
                            max.depth=mp,metrics="error",objective="binary:logistic", verbose=F))
##
optT <- which.min(boLcv[[4]]$test_error_mean)               # ؖ@狁߂œKȔŊwK
boL  <- xgboost(data=as.matrix(tr$x),label=tr$y,nround=optT,
               max.depth=mp,objective="binary:logistic",verbose=FALSE)
testerr <- mean((predict(boL,as.matrix(te$x))>1/2)!=te$y); testerr              # eXg덷
## g[jO덷ƌ،덷vbg
par(ps=16,mai=c(1,1,1,1))
ylim <- range(c(boLcv[[4]]$train_error_mean,boLcv[[4]]$test_error_mean))
 plot(boLcv[[4]]$train_error_mean,col=1,lty=1,lwd=2,xlab="",ylab="덷",ylim=ylim,type='l',main="spam f[^")
lines(boLcv[[4]]$test_error_mean, col=2,lty=2,lwd=2)
lines(cbind(0:T,testerr),lty=3,lwd=2)
legend('topright',c("،덷","g[jO덷","eXg덷"),col=c(2,1,1),lwd=c(2,2,2),lty=c(2,1,3),y.intersp=1.4)



readline(msg)
## u[XeBOɂ 0-1  ΐ̋
idx <- sample(nrow(x),4000)
tr <- xgb.DMatrix(data=as.matrix(x[ idx,]),label=y[ idx])    # g[jOf[^
te <- xgb.DMatrix(data=as.matrix(x[-idx,]),label=y[-idx])    # eXgf[^
watchlist <- list(train=tr, test=te)                         # eł̑vZ
T <- 2000                                                    # 
mp <- 5                                                      # wK@͐[ 5 ̌
boL <- xgb.train(data=tr,nround=T,max.depth=mp,watchlist=watchlist,objective="binary:logistic",
                 eval.metric="logloss",eval.metric="error",verbose=1,print_every_n=T)
## vbg
par(ps=16,mai=rep(1,4),mfrow=c(1,2))                                     
ylim <- range(c(boL$e[['train_error']],boL$e[['test_error']]))
 plot(boL$e[['train_error']],lwd=2,type='l',ylim=ylim,xlab='',ylab='01')
lines(boL$e[['test_error']] ,lwd=2,col=2,lty=2)
legend('bottomright',c('g[jOf[^','eXgf[^'),col=c(1,2),lwd=c(2,2),lty=c(1,2),y.intersp=1.5,bg="white")
ylim <- range(c(boL$e[['train_logloss']],boL$e[['test_logloss']]))
 plot(boL$e[['train_logloss']],lwd=2,type='l',ylim=ylim,xlab='',ylab='ΐ')
lines(boL$e[['test_logloss']] ,lwd=2,col=2,lty=2)
legend('bottomright',c('g[jOf[^','eXgf[^'),col=c(1,2),lwd=c(2,2),lty=c(1,2),y.intersp=1.5,bg="white")


readline(msg)
## m̂߂̓K؂Ȕؖ@ŋ߂D
T <- 2000                           # 
mp <- 5                             # wK@͐[ 5 ̌
K <- 5                              # 5-dؖ@
system.time(                        # vZԂv
            boLcv <- xgb.cv(data=tr,nrounds=T,max.depth=mp,nfold=K,
                            metrics="logloss",objective="binary:logistic",
                            verbose=1,print_every_n=T)
            )
which.min(boLcv$e[['test_logloss_mean']])    # œKȔ


par(ps=16,mai=rep(1,4),mfrow=c(1,1))
ylim <- range(c(boLcv$e[['test_logloss_mean']],boL$e[['test_logloss']]))
plot(boLcv$e[['test_logloss_mean']],lwd=3,col=2,lty=2,type='l',ylim=ylim,log='x',xlab='',ylab='ΐ')
 lines(boL$e[['test_logloss']],     lwd=3,col=1,lty=1)
legend('topleft',c('eXgf[^̑ΐ','ؖ@'),col=c(1,2),lwd=c(2,2),lty=c(1,2),y.intersp=1.5,bg="white")
