## file: Rcodes-chap13-gaussprocess.r
## usage: source('Rcodes-chap13-gaussprocess.r',echo=TRUE,max.deparse.length=Inf)
msg <- "------------------------ Type  <Return> to continue ------------------------: "
require(kernlab)               # kernelMatrix, gausspr
require(mlbench)               # mlbench.spirals
require(rBayesianOptimization) # BayesianOptimization


## KEXߒfɂPA
n <- 30                  # f[^
theta <- 1               # =1
sd <- 0.5                # Â̕W΍
GPk <- function(x,z){    # k(x,z)ʎ̓͂ɑ΂Ē`
  t(x)%*%z+sd^2*(all(x==z))
}
## f[^
X   <- matrix(rnorm(n,sd=3))
Yob <- X%*%theta+matrix(rnorm(n,sd=sd))
newx <- matrix(seq(-3,3,length=100))        # \_
## J[l֐̌vZ
Kob <- kernelMatrix(GPk,X)
kx  <- kernelMatrix(GPk,newx,X)
knewx <- kernelMatrix(GPk,newx,newx)
GPf   <- kx %*% solve(Kob,Yob)                      # KEXߒɂA֐̗\
GPv <- pmax(diag(knewx-kx %*% solve(Kob,t(kx))),0)  # \l̕UD
# vbg
plot(newx, GPf,type='l',lwd=2,main="A֐̐ƐM")  # 肵A֐
points(X,Yob)                                                           # f[^_
# M
lines(newx,GPf+sqrt(GPv),lty=2) 
lines(newx,GPf-sqrt(GPv),lty=2)


readline(msg)
## JEXߒe(GP)ɂA
n <- 30                    # f[^
theta <- 1                 # =1
sd <- 0.5                  # Â̕W΍
## f[^
X   <- matrix(rnorm(n,sd=3))
Yob <- X%*%theta+matrix(rnorm(n,sd=sd))
## KEXJ[lɂ\
gp <- gausspr(X,Yob,kernel="rbfdot",variance.model=TRUE, var=sd^2)
newx <- matrix(seq(-3,3,length=100))           # \_
GPf  <- predict(gp,newx)                       # A֐̐
GPsd <- predict(gp,newx,type="sdeviation")     # ̕W΍
## vbg
plot(newx, GPf, type='l',lwd=2, main="KEXߒf(KEXJ[l)Ő")
points(X,Yob)
lines(newx,GPf+GPsd,lty=2)
lines(newx,GPf-GPsd,lty=2)


readline(msg)
## JEXߒe(GP)ɂ锻ʕ
dat <- mlbench.spirals(200,cycles=1.2,sd=0.16)       # f[^
gp <- gausspr(dat$x,dat$c,kernel="rbfdot")           # KEXߒf(KEXJ[l)
newx   <- matrix(seq(-1.2,1.2,length=100))           
newdat <- as.matrix(expand.grid(newx,newx))          # 2̗\_
GPf    <- predict(gp, newdat, type="prob")           # m̗\l
par(mfrow=c(1,2))                                    # vbg
plot(dat$x,col=dat$c,lwd=2,main="f[^_")
image(matrix(GPf[,1],length(newx)),main="m̗\l")


readline(msg)
## xCYœK
dat <- mlbench.spirals(100,cycles=1.2,sd=0.16)    # f[^
ksvm_CVaccuracy <- function(logC, logsig){        # ړI֐`
  sv <- ksvm(dat$x,dat$c,kernel ="rbfdot",
             kpar=list(sigma=10^logsig), C=10^logC, cross=5)
  list(Score=1-cross(sv),Pred=1-cross(sv))
}
sig <- sigest(dat$x)                              # J[l͈̔͂f[^猈߂
## logC  logsig ͈̔͂߁CXg`̕ϐ bounds Ɋi[
bounds <- list(logC=c(-5,10),logsig=c(log(sig[1]/10,10),log(sig[3]*10,10)))


readline(msg)
## l֐UCBɂăxCYœKs
BOres <- BayesianOptimization(ksvm_CVaccuracy,bounds=bounds,init_points=10,n_iter=1,acq="ucb",kappa=1)
BOres$Best_Par   # œKȃp[^


readline(msg)
## l֐҉PʂɂăxCYœKs
BOres <- BayesianOptimization(ksvm_CVaccuracy,bounds=bounds,init_points=10, n_iter=1,acq="ei",eps=0.0)
BOres$Best_Par   # œKȃp[^
