## file: Rcodes-chap14-densityratio.r
## usage: source('Rcodes-chap14-densityratio.r',echo=TRUE,max.deparse.length=Inf)
msg <- "------------------------ Type  <Return> to continue ------------------------: "
require(kernlab)                  # kernelMatrix
require(mlbench)                  # LetterRecognition
require(Hotelling)                # hotelling.test
require(doParallel)               # foreach(vZ)
cl <- makeCluster(detectCores())  # NX^̍쐬
registerDoParallel(cl)


## x䐄̊֐`
## KEXJ[lɂ閧x䐄(WvZ): kernlab pbP[WKv
## de, nu: pde  pnu 瓾ꂽf[^s
## sigma: J[lp[^
## lambda: p[^
kernDR <- function(de,nu,
             sigma=sigest(rbind(de,nu))[2],
             lambda=min(nrow(de),nrow(nu))^(-0.9)){
  n <- nrow(de); m <- nrow(nu)        # f[^
  ## OšvZ 
  Kdd <- kernelMatrix(rbfdot(sigma=sigma), de)
  Kdn <- kernelMatrix(rbfdot(sigma=sigma), de, nu)
  ## Wp[^߂
  alpha <- as.vector(solve(Kdd+n*lambda*diag(n),-rowMeans(Kdn)/lambda))
  ## o
  list(alpha=alpha,sigma=sigma,lambda=lambda,dat=list(de=de,nu=nu))
}
## x̒l𐄒: kernlab pbP[WKv
## res: kernDȐo, newdat: \_
predict.DR <- function(res,newdat){
  # J[lx䐄̂ꂼ̍vZ  
  Wde <- kernelMult(rbfdot(sigma=res$sigma), newdat,res$dat$de,res$alpha)
  Wnu <- rowMeans(kernelMatrix(rbfdot(sigma=res$sigma), newdat,res$dat$nu))/res$lambda
  # óF\_ł̖x̒l
  c(pmax(Wde + Wnu,0))
}


readline(msg)
## x`
## source('funcDR.r')                    # kernDR, predict.DR 
## f[^ݒ 
n <- 100; m <- 200
de_mean <- 1   ; de_sd <- 0.8
nu_mean <- -0.5; nu_sd <- 1
newdat <- matrix(seq(-4,4,l=500))        # \_
## ^̖xvZ
tnu <-  dnorm(newdat, mean=nu_mean, sd=nu_sd)
tde <- (dnorm(newdat, mean=de_mean, sd=de_sd)+tnu)/2
tw <- tnu/tde
par(mfrow=c(1,1))
plot(newdat,tw,lwd=2,col=1,type='l',ylim=c(0,2.5),main="x")     # ^̖xvbg 


readline(msg)
## xf[^琄
## f[^
nu <- matrix(  rnorm(n, mean=nu_mean, sd=nu_sd))
de <- matrix(c(rnorm(n, mean=de_mean, sd=de_sd), rnorm(n, mean=nu_mean, sd=nu_sd)))
sigmas <- c(0.01, 0.1, 1)                                    # J[ľ
for(sigma in sigmas){
  res  <- kernDR(de,nu,sigma=sigma) #
  pred <- predict.DR(res,newdat)    #\
  lines(newdat,pred,col=2,lwd=2,lty=2) #vbg
}
## f[^_vbg
points(cbind(nu,0.2),col=3)
points(cbind(de,0.1),col=4)


readline(msg)
## x䐄̂߂̌ؖ@

## f[^ nu, de, newdat ͐ς
K <- 5                                # Kdؖ@ K ݒ
m <- nrow(nu);  n <- nrow(de);        # f[^
## J[lp[^̌𐶐
s <- sigest(rbind(de,nu))[1]
sigmas  <- exp(seq(log(s/100),log(s*10),l=20))   # J[lp[^̌
#  ͂PŒ (ׂ̌xNgł)
lambdas <- min(m,n)^(-0.9)
# fp[^̌
modelpars <- expand.grid(sigmas,lambdas)


readline(msg)
## fp[^ɑ΂錟،덷̌vZ
## nu, de f[^ꂼ KO[vɕ
idx_nu <- rep(1:K,ceiling(m/K))[1:m] 
idx_de <- rep(1:K,ceiling(n/K))[1:n]
cvloss <- foreach(i=1:nrow(modelpars),.combine=c,.packages="kernlab")%dopar%{  # %dopar%ƂƕvZ
  ## fp[^ݒ
  sigma <- modelpars[i,1]; lambda <- modelpars[i,2]
  tmpcvloss <- c()
  for(cvk in 1:K){ # ؖ@̌vZ
    ## g[jOf[^
    trnu <- nu[idx_nu!=cvk,,drop=FALSE]
    trde <- de[idx_de!=cvk,,drop=FALSE]
    ## eXgf[^
    tenu <- nu[idx_nu==cvk,,drop=FALSE]
    tede <- de[idx_de==cvk,,drop=FALSE]
    ## w肳ꂽfp[^Ŗx𐄒
    res <- kernDR(trde,trnu,sigma=sigma,lambda=lambda)
    ## ،덷̌vZ
    wnu <- predict.DR(res,tenu)
    wde <- predict.DR(res,tede)
    tmpcvloss <- c(tmpcvloss, mean(wde^2)/2-mean(wnu)) 
  }
  mean(tmpcvloss)
}
## œKȃfp[^
opt_sigma  <- modelpars[which.min(cvloss),1]
opt_lambda <- modelpars[which.min(cvloss),2]
print(c(opt_sigma, opt_lambda))    ## œKȃfp[^


readline(msg)
## vbg
par(mfrow=c(1,2))
plot(sigmas,cvloss,log='x')        ## sigma ɑ΂錟،덷vbg
## œKȃfp[^Ŗx𐄒E\
res <- kernDR(de,nu,sigma=opt_sigma,lambda=opt_lambda)
pred <- predict.DR(res,newdat)
## vbg
tnu <-  dnorm(newdat, mean=nu_mean, sd=nu_sd)
tde <- (dnorm(newdat, mean=de_mean, sd=de_sd)+tnu)/2
tw <- tnu/tde
plot(newdat,tw,lwd=2,col=1,type='l',ylim=c(0,2.4), xlab="x", ylab="x")    # ^̖x
lines(newdat,pred,col=2,lwd=4,lty=2)                                          # œKȃfp[^̌
## ̑̃fp[^Ő肵ʂvbg
res <- kernDR(de,nu,sigma=sigmas[1],lambda=opt_lambda)
pred <- predict.DR(res,newdat)
lines(newdat,pred,col=5,lwd=2,lty=3)
## 
res <- kernDR(de,nu,sigma=sigmas[length(sigmas)],lambda=opt_lambda)
pred <- predict.DR(res,newdat)
lines(newdat,pred,col=5,lwd=2,lty=3)
## f[^_̃vbg
points(cbind(nu,0.2),col=3)
points(cbind(de,0.1),col=4)


readline(msg)
## ϗʃVtg̉ẲA
f <- function(x){(x+2)*x*(x-3)}     # ^̊֐
ntr <- 100; nte <- 100              # f[^
## z̃p[^ݒ 
mtr <- -1.4; sdtr <- 0.7
mte <-  0.8; sdte <- 0.8
## g[jOf[^
xtr <- matrix(rnorm(ntr,mean=mtr,sd=sdtr))
ytr <- f(xtr) + rnorm(ntr,sd=2)
## eXgf[^
xte <- matrix(rnorm(ntr,mean=mte,sd=sdte))
yte <- f(xte) + rnorm(ntr,sd=2)
predw <- predict.DR(kernDR(xtr,xte),xtr)       # g[jOf[^_ł̖x𐄒
## dݕtŏ@ŉAp[^𐄒
W <- sqrt(diag(predw))  
X <- cbind(1,xtr)
WX <- W %*%X; WY <- W %*% ytr;
estTheta <- c(solve(t(WX)%*%WX, t(WX)%*%WY)) # dݕtŏ@̐p[^


readline(msg)
## ϗʃVtg̉ẲÁFvbg
par(mfrow=c(1,1))
plot(xtr,ytr,col=2,xlim=c(-3,3),ylim=c(-18,17),lwd=1.5,xlab='x',ylab='y',main="ϗʃVtg̉ł̉A")
points(xte,yte,col=4,lwd=1.5)
x <- seq(min(c(xtr,xte)),max(c(xtr,xte)),l=100); pX <- cbind(1,x)
lmest <- lm.fit(cbind(1,xtr),ytr)$coef          
lines(x, pX %*% lmest,  lwd=4, col=3, lty=2)   # ŏ@̌ʂvbg
lmopt <- lm.fit(cbind(1,xte),yte)$coef          
lines(x, pX %*% lmopt, lwd=4, col=1, lty=1)    # œKȂPvbg
lines(x, f(x),col=1,lwd=3,lty=2)               # ^̉A֐
lines(x, pX %*% estTheta,lwd=7,col=6,lty=3)    # dݕtŏ@
text(2, 13,expression(paste("ŏ@")),col=3)
text(2,-13,expression(paste("ڕW")),col=1)
text(1.2,1.7,expression(paste("dݕtŏ@")),col=6)


readline(msg)
## W{
n <- 300; m <- 300                              # f[^
data(LetterRecognition); d <- LetterRecognition # f[^ǂݍ
de <- as.matrix(d[d[,1]=='C',-1])
de <- de[sample(nrow(de),n),]                   # f[^s de 
nu <- as.matrix(d[d[,1]=='G',-1])
nu <- nu[sample(nrow(nu),m),]                   # f[^s nu 


readline(msg)
## 
hotelling.test(de,nu)$pval     # zeOT^2pl

readline(msg)
## x䐄gבւ
res  <- kernDR(de,nu)                          # x̐
L1distEst <- mean(abs(1-predict.DR(res,de)))   # L1̐
## בւ̌JԂݒDԂ|Ȃ珬Ȓlɐݒ
nperm <- 4000
permL1dist <- foreach(i=1:nperm,.combine=c,.packages="kernlab")%dopar%{# vZ
  ## f[^ĕבւ
  idx <- which(sample(c(rep(0,nrow(nu)),rep(1,nrow(de))))==1)
  perm_de <- rbind(de,nu)[ idx,,drop=FALSE]
  perm_nu <- rbind(de,nu)[-idx,,drop=FALSE]
  ## L1𐄒
  res <- kernDR(perm_de,perm_nu)            # x̐
  dr  <- predict.DR(res,perm_de)            # deł̖x̒l
  mean(abs(1-dr))                           # L1𐄒
}
mean(L1distEst < permL1dist)                # בւɂ pl

readline(msg)
## XP[Of[^
de <- scale(de)
nu <- scale(nu)

readline(msg)
## XP[Of[^ɑ΂zeOT^2
hotelling.test(de,nu)$pval     # zeOT^2pl

readline(msg)
## XP[Of[^ɑ΂בւ
res  <- kernDR(de,nu)                       # x̐
L1distEst <- mean(abs(1-predict.DR(res,de)))   # L1̐
## בւ̌JԂݒDԂ|Ȃ珬Ȓlɐݒ
nperm <- 4000
permL1dist <- foreach(i=1:nperm,.combine=c,.packages="kernlab")%dopar%{# vZ
  ## f[^ĕבւ
  idx <- which(sample(c(rep(0,nrow(nu)),rep(1,nrow(de))))==1)
  perm_de <- rbind(de,nu)[ idx,,drop=FALSE]
  perm_nu <- rbind(de,nu)[-idx,,drop=FALSE]
  ## L1𐄒
  res <- kernDR(perm_de,perm_nu)            # x̐
  dr  <- predict.DR(res,perm_de)               # deł̖x̒l
  mean(abs(1-dr))                           # L1𐄒
}
mean(L1distEst < permL1dist)                # בւɂ pl
stopCluster(cl)                             # vZI 

